package cn.wise.sc.consume.business.service.impl;

import cn.hutool.json.JSONException;
import cn.wise.sc.consume.business.entity.SmsAuth;
import cn.wise.sc.consume.business.mapper.SmsAuthMapper;
import cn.wise.sc.consume.business.service.SmsAuthService;
import cn.wise.sc.consume.business.util.SMSUtil;
import com.github.qcloudsms.SmsSingleSender;
import com.github.qcloudsms.SmsSingleSenderResult;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import javax.xml.ws.http.HTTPException;
import java.io.IOException;
import java.util.Date;
import java.util.List;
import java.util.Random;
import java.util.concurrent.TimeUnit;

@Service
public class SmsAuthServiceImpl implements SmsAuthService {

	private static final Logger log = LoggerFactory.getLogger("adminLogger");
	@Resource
	private StringRedisTemplate stringRedisTemplate;
	@Autowired
	private SmsAuthMapper smsAuthDao;


	private static final String SHIRO_TOKEN_SMSCODE = "shiro:token:smscode";

	public final static String FORGET_PASSWORD = "2";//忘记密码
	public final static String LOGIN = "1";//登录


	//短信应用SDK AppID
	private static final int appid = 1400313569; //140开头
	//短信应用SDK AppKey
	private static final String appkey = "e3baf74f68aebb837fe9263a3cd4c821";
	//短信模板ID， 需要在短信应用中申请
	private static final int TTEMPLATEID = 532621;
	//签名
	private static final String SMSSING = "腾闻";


	@Override
	public void save(SmsAuth smsAuth) {
		smsAuthDao.save(smsAuth);
	}


	/**
	 * 验证短信发送时间  一分钟之内一个手机号只能发送一条
	 *
	 * @param phone
	 */
	@Override
	public Boolean getSendDate(String phone, String type) {
		try {
			if (StringUtils.isNoneBlank(phone)) {
				//当前时间
				Date d1 = new Date();
				Date endDate = new Date(d1.getTime() - 60 * 1000);//查看六十秒钱的数据
				List<SmsAuth> smsAuthList = smsAuthDao.selectList(phone, type, endDate);
				if (smsAuthList.size() > 0) {
					//说明60秒内已经发送过短信
					return false;
				}
				return true;
			}
			return false;
		} catch (Exception e) {
			log.error("获取验证码异常：" + e.getMessage());
		}
		return false;
	}


	/*
		生成6位验证码
	 */
	private int random() {
		Random r = new Random();
		StringBuffer sb = new StringBuffer();
		int[] c = new int[6];
		for (int i = 0; i < 6; i++) {
			c[i] = r.nextInt(9) + 1;
			sb.append(c[i]);
		}
		return Integer.parseInt(sb.toString());

	}
	/**
      * 指定模板ＩＤ发送短信
      * @param number 用户手机号
      * @return OK 成功  null 失败
      */
	@Override
	public  Boolean sendMesModel(String phone, String type){
		try {
			int yzm = random();
			String code = Integer.toString(yzm);

			Boolean result = SMSUtil.sendCode(phone, code);
			if (result) {
				stringRedisTemplate.delete(SHIRO_TOKEN_SMSCODE + phone.trim());
				stringRedisTemplate.opsForValue().set(SHIRO_TOKEN_SMSCODE + phone.trim()+type, code, 3, TimeUnit.MINUTES);
				SmsAuth smsAuth = new SmsAuth();
//				smsAuth.setCreateTime(new Date());
				smsAuth.setIphone(phone);
				smsAuth.setCode(code);
				smsAuth.setType(type);
				smsAuth.setRemark(null);
				return smsAuthDao.save(smsAuth);
			}else{
				return false;
			}

		} catch (HTTPException e) {
			// HTTP响应码错误
			e.printStackTrace();
		} catch (JSONException e) {
			// json解析错误
			e.printStackTrace();
		}
		return false;
	}














}
